// This test uses '<prefix>-SAME: {{^}}' to start matching immediately where the
// previous check finished matching (specifically, caret is not treated as
// matching a start of line when used like this in FileCheck).

// RUN: not %clang_cc1 -triple avr--- -target-cpu not-a-cpu -fsyntax-only %s 2>&1 | FileCheck %s
// CHECK: error: unknown target CPU 'not-a-cpu'
// CHECK-NEXT: note: valid target CPU values are:
// CHECK-SAME: {{^}} avr1
// CHECK-SAME: {{^}}, at90s1200
// CHECK-SAME: {{^}}, attiny11
// CHECK-SAME: {{^}}, attiny12
// CHECK-SAME: {{^}}, attiny15
// CHECK-SAME: {{^}}, attiny28
// CHECK-SAME: {{^}}, avr2
// CHECK-SAME: {{^}}, at90s2313
// CHECK-SAME: {{^}}, at90s2323
// CHECK-SAME: {{^}}, at90s2333
// CHECK-SAME: {{^}}, at90s2343
// CHECK-SAME: {{^}}, attiny22
// CHECK-SAME: {{^}}, attiny26
// CHECK-SAME: {{^}}, at86rf401
// CHECK-SAME: {{^}}, at90s4414
// CHECK-SAME: {{^}}, at90s4433
// CHECK-SAME: {{^}}, at90s4434
// CHECK-SAME: {{^}}, at90s8515
// CHECK-SAME: {{^}}, at90c8534
// CHECK-SAME: {{^}}, at90s8535
// CHECK-SAME: {{^}}, avr25
// CHECK-SAME: {{^}}, ata5272
// CHECK-SAME: {{^}}, ata6616c
// CHECK-SAME: {{^}}, attiny13
// CHECK-SAME: {{^}}, attiny13a
// CHECK-SAME: {{^}}, attiny2313
// CHECK-SAME: {{^}}, attiny2313a
// CHECK-SAME: {{^}}, attiny24
// CHECK-SAME: {{^}}, attiny24a
// CHECK-SAME: {{^}}, attiny4313
// CHECK-SAME: {{^}}, attiny44
// CHECK-SAME: {{^}}, attiny44a
// CHECK-SAME: {{^}}, attiny84
// CHECK-SAME: {{^}}, attiny84a
// CHECK-SAME: {{^}}, attiny25
// CHECK-SAME: {{^}}, attiny45
// CHECK-SAME: {{^}}, attiny85
// CHECK-SAME: {{^}}, attiny261
// CHECK-SAME: {{^}}, attiny261a
// CHECK-SAME: {{^}}, attiny441
// CHECK-SAME: {{^}}, attiny461
// CHECK-SAME: {{^}}, attiny461a
// CHECK-SAME: {{^}}, attiny841
// CHECK-SAME: {{^}}, attiny861
// CHECK-SAME: {{^}}, attiny861a
// CHECK-SAME: {{^}}, attiny87
// CHECK-SAME: {{^}}, attiny43u
// CHECK-SAME: {{^}}, attiny48
// CHECK-SAME: {{^}}, attiny88
// CHECK-SAME: {{^}}, attiny828
// CHECK-SAME: {{^}}, avr3
// CHECK-SAME: {{^}}, at43usb355
// CHECK-SAME: {{^}}, at76c711
// CHECK-SAME: {{^}}, avr31
// CHECK-SAME: {{^}}, atmega103
// CHECK-SAME: {{^}}, at43usb320
// CHECK-SAME: {{^}}, avr35
// CHECK-SAME: {{^}}, attiny167
// CHECK-SAME: {{^}}, at90usb82
// CHECK-SAME: {{^}}, at90usb162
// CHECK-SAME: {{^}}, ata5505
// CHECK-SAME: {{^}}, ata6617c
// CHECK-SAME: {{^}}, ata664251
// CHECK-SAME: {{^}}, atmega8u2
// CHECK-SAME: {{^}}, atmega16u2
// CHECK-SAME: {{^}}, atmega32u2
// CHECK-SAME: {{^}}, attiny1634
// CHECK-SAME: {{^}}, avr4
// CHECK-SAME: {{^}}, atmega8
// CHECK-SAME: {{^}}, ata6289
// CHECK-SAME: {{^}}, atmega8a
// CHECK-SAME: {{^}}, ata6285
// CHECK-SAME: {{^}}, ata6286
// CHECK-SAME: {{^}}, ata6612c
// CHECK-SAME: {{^}}, atmega48
// CHECK-SAME: {{^}}, atmega48a
// CHECK-SAME: {{^}}, atmega48pa
// CHECK-SAME: {{^}}, atmega48pb
// CHECK-SAME: {{^}}, atmega48p
// CHECK-SAME: {{^}}, atmega88
// CHECK-SAME: {{^}}, atmega88a
// CHECK-SAME: {{^}}, atmega88p
// CHECK-SAME: {{^}}, atmega88pa
// CHECK-SAME: {{^}}, atmega88pb
// CHECK-SAME: {{^}}, atmega8515
// CHECK-SAME: {{^}}, atmega8535
// CHECK-SAME: {{^}}, atmega8hva
// CHECK-SAME: {{^}}, at90pwm1
// CHECK-SAME: {{^}}, at90pwm2
// CHECK-SAME: {{^}}, at90pwm2b
// CHECK-SAME: {{^}}, at90pwm3
// CHECK-SAME: {{^}}, at90pwm3b
// CHECK-SAME: {{^}}, at90pwm81
// CHECK-SAME: {{^}}, avr5
// CHECK-SAME: {{^}}, ata5702m322
// CHECK-SAME: {{^}}, ata5782
// CHECK-SAME: {{^}}, ata5790
// CHECK-SAME: {{^}}, ata5790n
// CHECK-SAME: {{^}}, ata5791
// CHECK-SAME: {{^}}, ata5795
// CHECK-SAME: {{^}}, ata5831
// CHECK-SAME: {{^}}, ata6613c
// CHECK-SAME: {{^}}, ata6614q
// CHECK-SAME: {{^}}, ata8210
// CHECK-SAME: {{^}}, ata8510
// CHECK-SAME: {{^}}, atmega16
// CHECK-SAME: {{^}}, atmega16a
// CHECK-SAME: {{^}}, atmega161
// CHECK-SAME: {{^}}, atmega162
// CHECK-SAME: {{^}}, atmega163
// CHECK-SAME: {{^}}, atmega164a
// CHECK-SAME: {{^}}, atmega164p
// CHECK-SAME: {{^}}, atmega164pa
// CHECK-SAME: {{^}}, atmega165
// CHECK-SAME: {{^}}, atmega165a
// CHECK-SAME: {{^}}, atmega165p
// CHECK-SAME: {{^}}, atmega165pa
// CHECK-SAME: {{^}}, atmega168
// CHECK-SAME: {{^}}, atmega168a
// CHECK-SAME: {{^}}, atmega168p
// CHECK-SAME: {{^}}, atmega168pa
// CHECK-SAME: {{^}}, atmega168pb
// CHECK-SAME: {{^}}, atmega169
// CHECK-SAME: {{^}}, atmega169a
// CHECK-SAME: {{^}}, atmega169p
// CHECK-SAME: {{^}}, atmega169pa
// CHECK-SAME: {{^}}, atmega32
// CHECK-SAME: {{^}}, atmega32a
// CHECK-SAME: {{^}}, atmega323
// CHECK-SAME: {{^}}, atmega324a
// CHECK-SAME: {{^}}, atmega324p
// CHECK-SAME: {{^}}, atmega324pa
// CHECK-SAME: {{^}}, atmega324pb
// CHECK-SAME: {{^}}, atmega325
// CHECK-SAME: {{^}}, atmega325a
// CHECK-SAME: {{^}}, atmega325p
// CHECK-SAME: {{^}}, atmega325pa
// CHECK-SAME: {{^}}, atmega3250
// CHECK-SAME: {{^}}, atmega3250a
// CHECK-SAME: {{^}}, atmega3250p
// CHECK-SAME: {{^}}, atmega3250pa
// CHECK-SAME: {{^}}, atmega328
// CHECK-SAME: {{^}}, atmega328p
// CHECK-SAME: {{^}}, atmega328pb
// CHECK-SAME: {{^}}, atmega329
// CHECK-SAME: {{^}}, atmega329a
// CHECK-SAME: {{^}}, atmega329p
// CHECK-SAME: {{^}}, atmega329pa
// CHECK-SAME: {{^}}, atmega3290
// CHECK-SAME: {{^}}, atmega3290a
// CHECK-SAME: {{^}}, atmega3290p
// CHECK-SAME: {{^}}, atmega3290pa
// CHECK-SAME: {{^}}, atmega406
// CHECK-SAME: {{^}}, atmega64
// CHECK-SAME: {{^}}, atmega64a
// CHECK-SAME: {{^}}, atmega640
// CHECK-SAME: {{^}}, atmega644
// CHECK-SAME: {{^}}, atmega644a
// CHECK-SAME: {{^}}, atmega644p
// CHECK-SAME: {{^}}, atmega644pa
// CHECK-SAME: {{^}}, atmega645
// CHECK-SAME: {{^}}, atmega645a
// CHECK-SAME: {{^}}, atmega645p
// CHECK-SAME: {{^}}, atmega649
// CHECK-SAME: {{^}}, atmega649a
// CHECK-SAME: {{^}}, atmega649p
// CHECK-SAME: {{^}}, atmega6450
// CHECK-SAME: {{^}}, atmega6450a
// CHECK-SAME: {{^}}, atmega6450p
// CHECK-SAME: {{^}}, atmega6490
// CHECK-SAME: {{^}}, atmega6490a
// CHECK-SAME: {{^}}, atmega6490p
// CHECK-SAME: {{^}}, atmega64rfr2
// CHECK-SAME: {{^}}, atmega644rfr2
// CHECK-SAME: {{^}}, atmega16hva
// CHECK-SAME: {{^}}, atmega16hva2
// CHECK-SAME: {{^}}, atmega16hvb
// CHECK-SAME: {{^}}, atmega16hvbrevb
// CHECK-SAME: {{^}}, atmega32hvb
// CHECK-SAME: {{^}}, atmega32hvbrevb
// CHECK-SAME: {{^}}, atmega64hve
// CHECK-SAME: {{^}}, atmega64hve2
// CHECK-SAME: {{^}}, at90can32
// CHECK-SAME: {{^}}, at90can64
// CHECK-SAME: {{^}}, at90pwm161
// CHECK-SAME: {{^}}, at90pwm216
// CHECK-SAME: {{^}}, at90pwm316
// CHECK-SAME: {{^}}, atmega32c1
// CHECK-SAME: {{^}}, atmega64c1
// CHECK-SAME: {{^}}, atmega16m1
// CHECK-SAME: {{^}}, atmega32m1
// CHECK-SAME: {{^}}, atmega64m1
// CHECK-SAME: {{^}}, atmega16u4
// CHECK-SAME: {{^}}, atmega32u4
// CHECK-SAME: {{^}}, atmega32u6
// CHECK-SAME: {{^}}, at90usb646
// CHECK-SAME: {{^}}, at90usb647
// CHECK-SAME: {{^}}, at90scr100
// CHECK-SAME: {{^}}, at94k
// CHECK-SAME: {{^}}, m3000
// CHECK-SAME: {{^}}, avr51
// CHECK-SAME: {{^}}, atmega128
// CHECK-SAME: {{^}}, atmega128a
// CHECK-SAME: {{^}}, atmega1280
// CHECK-SAME: {{^}}, atmega1281
// CHECK-SAME: {{^}}, atmega1284
// CHECK-SAME: {{^}}, atmega1284p
// CHECK-SAME: {{^}}, atmega128rfa1
// CHECK-SAME: {{^}}, atmega128rfr2
// CHECK-SAME: {{^}}, atmega1284rfr2
// CHECK-SAME: {{^}}, at90can128
// CHECK-SAME: {{^}}, at90usb1286
// CHECK-SAME: {{^}}, at90usb1287
// CHECK-SAME: {{^}}, avr6
// CHECK-SAME: {{^}}, atmega2560
// CHECK-SAME: {{^}}, atmega2561
// CHECK-SAME: {{^}}, atmega256rfr2
// CHECK-SAME: {{^}}, atmega2564rfr2
// CHECK-SAME: {{^}}, avrxmega2
// CHECK-SAME: {{^}}, atxmega16a4
// CHECK-SAME: {{^}}, atxmega16a4u
// CHECK-SAME: {{^}}, atxmega16c4
// CHECK-SAME: {{^}}, atxmega16d4
// CHECK-SAME: {{^}}, atxmega32a4
// CHECK-SAME: {{^}}, atxmega32a4u
// CHECK-SAME: {{^}}, atxmega32c3
// CHECK-SAME: {{^}}, atxmega32c4
// CHECK-SAME: {{^}}, atxmega32d3
// CHECK-SAME: {{^}}, atxmega32d4
// CHECK-SAME: {{^}}, atxmega32e5
// CHECK-SAME: {{^}}, atxmega16e5
// CHECK-SAME: {{^}}, atxmega8e5
// CHECK-SAME: {{^}}, avrxmega4
// CHECK-SAME: {{^}}, atxmega64a3
// CHECK-SAME: {{^}}, atxmega64a3u
// CHECK-SAME: {{^}}, atxmega64a4u
// CHECK-SAME: {{^}}, atxmega64b1
// CHECK-SAME: {{^}}, atxmega64b3
// CHECK-SAME: {{^}}, atxmega64c3
// CHECK-SAME: {{^}}, atxmega64d3
// CHECK-SAME: {{^}}, atxmega64d4
// CHECK-SAME: {{^}}, avrxmega5
// CHECK-SAME: {{^}}, atxmega64a1
// CHECK-SAME: {{^}}, atxmega64a1u
// CHECK-SAME: {{^}}, avrxmega6
// CHECK-SAME: {{^}}, atxmega128a3
// CHECK-SAME: {{^}}, atxmega128a3u
// CHECK-SAME: {{^}}, atxmega128b1
// CHECK-SAME: {{^}}, atxmega128b3
// CHECK-SAME: {{^}}, atxmega128c3
// CHECK-SAME: {{^}}, atxmega128d3
// CHECK-SAME: {{^}}, atxmega128d4
// CHECK-SAME: {{^}}, atxmega192a3
// CHECK-SAME: {{^}}, atxmega192a3u
// CHECK-SAME: {{^}}, atxmega192c3
// CHECK-SAME: {{^}}, atxmega192d3
// CHECK-SAME: {{^}}, atxmega256a3
// CHECK-SAME: {{^}}, atxmega256a3u
// CHECK-SAME: {{^}}, atxmega256a3b
// CHECK-SAME: {{^}}, atxmega256a3bu
// CHECK-SAME: {{^}}, atxmega256c3
// CHECK-SAME: {{^}}, atxmega256d3
// CHECK-SAME: {{^}}, atxmega384c3
// CHECK-SAME: {{^}}, atxmega384d3
// CHECK-SAME: {{^}}, avrxmega7
// CHECK-SAME: {{^}}, atxmega128a1
// CHECK-SAME: {{^}}, atxmega128a1u
// CHECK-SAME: {{^}}, atxmega128a4u
// CHECK-SAME: {{^}}, avrtiny
// CHECK-SAME: {{^}}, attiny4
// CHECK-SAME: {{^}}, attiny5
// CHECK-SAME: {{^}}, attiny9
// CHECK-SAME: {{^}}, attiny10
// CHECK-SAME: {{^}}, attiny20
// CHECK-SAME: {{^}}, attiny40
// CHECK-SAME: {{^}}, attiny102
// CHECK-SAME: {{^}}, attiny104
// CHECK-SAME: {{^}}, avrxmega3
// CHECK-SAME: {{^}}, attiny202
// CHECK-SAME: {{^}}, attiny402
// CHECK-SAME: {{^}}, attiny204
// CHECK-SAME: {{^}}, attiny404
// CHECK-SAME: {{^}}, attiny804
// CHECK-SAME: {{^}}, attiny1604
// CHECK-SAME: {{^}}, attiny406
// CHECK-SAME: {{^}}, attiny806
// CHECK-SAME: {{^}}, attiny1606
// CHECK-SAME: {{^}}, attiny807
// CHECK-SAME: {{^}}, attiny1607
// CHECK-SAME: {{^}}, attiny212
// CHECK-SAME: {{^}}, attiny412
// CHECK-SAME: {{^}}, attiny214
// CHECK-SAME: {{^}}, attiny414
// CHECK-SAME: {{^}}, attiny814
// CHECK-SAME: {{^}}, attiny1614
// CHECK-SAME: {{^}}, attiny416
// CHECK-SAME: {{^}}, attiny816
// CHECK-SAME: {{^}}, attiny1616
// CHECK-SAME: {{^}}, attiny3216
// CHECK-SAME: {{^}}, attiny417
// CHECK-SAME: {{^}}, attiny817
// CHECK-SAME: {{^}}, attiny1617
// CHECK-SAME: {{^}}, attiny3217
// CHECK-SAME: {{^}}, attiny1624
// CHECK-SAME: {{^}}, attiny1626
// CHECK-SAME: {{^}}, attiny1627
// CHECK-SAME: {{^}}, atmega808
// CHECK-SAME: {{^}}, atmega809
// CHECK-SAME: {{^}}, atmega1608
// CHECK-SAME: {{^}}, atmega1609
// CHECK-SAME: {{^}}, atmega3208
// CHECK-SAME: {{^}}, atmega3209
// CHECK-SAME: {{^}}, atmega4808
// CHECK-SAME: {{^}}, atmega4809
// CHECK-SAME: {{$}}
